function comparetoall(databasePath,subdirs,varargin)


definput.keyvals.maxit=200;
definput.keyvals.maxsamples=[];
definput.keyvals.a=256;
definput.keyvals.M=1024;
definput.keyvals.thr1=1e-1;
definput.keyvals.thr2=1e-10;
definput.keyvals.exportdir = [];
definput.keyvals.expname = 'experiment';
definput.keyvals.rtisiiters = [1,2,3,4,5,12,25];
definput.flags.winmod = {'gauss','truncgauss','hann','hamming'};
definput.flags.writewavs = {'donotstorewavs','storewavs'};
definput.flags.warmstart = {'nowarmstart','wsheapint','wsspsi'};
definput.flags.lbfgs = {'dolbfgs','excludelbfgs'};
definput.keyvals.maxwavno = [];
[flags,kv,a,M]=ltfatarghelper({'a','M'},definput,varargin);
maxit = kv.maxit;


numFiles = 0;


prefix = [databasePath,filesep];
speakers = subdirs;


CheapintAll = 0;
CspsiAll = 0;
glarandAll = zeros(maxit,1);
glazeroAll = zeros(maxit,1);
fglaAll = zeros(maxit,1);
lbfgsAll = zeros(maxit,1);
leglaAll = zeros(maxit,1);
fleglaAll = zeros(maxit,1);
rtisiAll = zeros(numel(kv.rtisiiters),1);
lertisiAll = zeros(numel(kv.rtisiiters),1);
rtisiXaxis = kv.rtisiiters*(M/a);

lbfgsInvalidFilesNo = 0;

wsstring = '';
if ~flags.do_nowarmstart
    wsstring = ['_',flags.warmstart];
end

for jj = 1:numel(speakers)
    speaker = speakers{jj};
    
    dirname = [prefix,speaker,filesep];
    allwavs = dir([dirname,'*.wav']);
    
    if ~isempty(kv.maxwavno)
        allwavs = allwavs(1:min([kv.maxwavno,numel(allwavs)]));
    end
    
    numFiles = numFiles + numel(allwavs);
    
    allwavsCell = arrayfun(@(wav) [dirname,wav.name],allwavs,'UniformOutput',0);
    
    for ii=1:numel(allwavs)
        [~,name] = fileparts(allwavsCell{ii});
        outputdir = [kv.exportdir,filesep,mfilename,'_',kv.expname,'_',flags.winmod];
        nameoutdir = [outputdir,filesep,name,filesep];
        
        Cres = compareonewav(allwavsCell{ii},kv,flags,outputdir,nameoutdir);
        
        
        [Cheapint,Cspsi,Crelres,Cfinal] = deal(Cres{:});
        
        Cfinaldb = cellfun(@(cEl) 20*log10(cEl),Cfinal,'UniformOutput',0);
        Cheapintdb = 20*log10(Cheapint);
        Cspsidb = 20*log10(Cspsi);
        
            
        if ~flags.do_nowarmstart
            [relresglazero,relreslbfgs,relresflegla] = deal(Crelres{:});
            [Cglazero,Clbfgs,Cflegla] = deal(Cfinaldb{:});
            
            if ~flags.do_excludelbfgs
                fprintf(['Heapint: %.2f, SPSI: %.2f, GLA: %.2f,',...
                    'lBFGS: %.2f, FleLGA: %.2f, file: %s \n'],...
                    Cheapintdb,Cspsidb,Cglazero,Clbfgs,Cflegla,allwavsCell{ii});
                labels = {'lBFGS','FleGLA','GLA'};
                res = {relreslbfgs,relresflegla,relresglazero};
            else
                fprintf(['Heapint: %.2f, SPSI: %.2f, GLA: %.2f,',...
                    'FleLGA: %.2f, file: %s \n'],...
                    Cheapintdb,Cspsidb,Cglazero,Cflegla,allwavsCell{ii});
                labels = {'FleGLA','GLA'};
                res = {relresflegla,relresglazero};
            end
        else
            [relresglazero,relreslbfgs,relresflegla,relresrtisi]=deal(Crelres{:});
            [Cglazero,Clbfgs,Cflegla,Crtisi] = deal(Cfinaldb{:});
            
            if ~flags.do_excludelbfgs
                fprintf(['Heapint: %.2f, SPSI: %.2f, GLA zero: %.2f,',...
                    'lBFGS: %.2f, FleLGA: %.2f, RTISI: %.2f, file: %s \n'],...
                    Cheapintdb,Cspsidb,Cglazero,Clbfgs,Cflegla,Crtisi,allwavsCell{ii});
                labels = {'lBFGS','FleGLA','GLA','RTISI-LA'};
                res = {relreslbfgs,relresflegla,relresglazero, relresrtisi};
            else
                fprintf(['Heapint: %.2f, SPSI: %.2f, GLA: %.2f,',...
                    'FleLGA: %.2f, RTISI: %.2f, file: %s \n'],...
                    Cheapintdb,Cspsidb,Cglazero,Cflegla,Crtisi,allwavsCell{ii});  
                labels = {'FleGLA','GLA','RTISI-LA'};
                res = {relresflegla,relresglazero, relresrtisi};
            end
        end

        save([nameoutdir,name,'_comparison',wsstring,'.mat'],...
                    'Cheapint','labels','res','maxit','rtisiXaxis');
        
        
        CheapintAll = CheapintAll + Cheapint;
        CspsiAll = CspsiAll + Cspsi;
        glazeroAll = glazeroAll + postpad(relresglazero,maxit,relresglazero(end));
        %fglaAll = fglaAll + postpad(relresfgla,maxit,relresfgla(end));
        if ~isnan(relreslbfgs)
            lbfgsAll = lbfgsAll + postpad(relreslbfgs,maxit,relreslbfgs(end));
        else
            lbfgsInvalidFilesNo = lbfgsInvalidFilesNo + 1;
        end
        %leglaAll = leglaAll + postpad(relreslegla,maxit,relreslegla(end));
        fleglaAll = fleglaAll + postpad(relresflegla,maxit,relresflegla(end));
        
        if flags.do_nowarmstart
            %glarandAll = glarandAll + postpad(relresglarand,maxit,relresglarand(end));
            rtisiAll = rtisiAll + relresrtisi;
        end
   
    end
end


%figure(10);

glazeroMean = glazeroAll./numFiles;
%fglaMean = fglaAll./numFiles;
lbfgsMean = lbfgsAll./(numFiles-lbfgsInvalidFilesNo);
%leglaMean = leglaAll./numFiles;
fleglaMean = fleglaAll./numFiles;


CspsiAllMean = CspsiAll./numFiles;
CheapintAllMean = CheapintAll./numFiles;
Cheapint = CheapintAllMean;

if ~flags.do_nowarmstart
    if ~flags.do_excludelbfgs
        labels = {'lBFGS','FleGLA','GLA'};
        res = {lbfgsMean,fleglaMean,glazeroMean};
        %plot(20*log10(cell2mat(res)));
        %legend(labels);
    else
        labels = {'FleGLA','GLA'};
        res = {fleglaMean,glazeroMean};
        %plot(20*log10(cell2mat(res)));
        %legend(labels)        
    end
else
    %glarandMean = glarandAll./numFiles;
    rtisiMean = rtisiAll./numFiles;
    if ~flags.do_excludelbfgs
        labels = {'lBFGS','FleGLA','GLA','RTISI-LA'};
        res = {lbfgsMean,fleglaMean,glazeroMean};
        %plot(20*log10(cell2mat(res)));
        %hold on; 
        %plot(rtisiXaxis,20*log10(rtisiMean),'ko--');
        %hold off;
        res{end+1} = rtisiMean;
        %legend(labels);
    else
        labels = {'FleGLA','GLA','RTISI-LA'};
        res = {fleglaMean,glazeroMean};
        %plot(20*log10(cell2mat(res)));
        %hold on; 
        %plot(rtisiXaxis,20*log10(rtisiMean),'ko--');
        %hold off;
        res{end+1} = rtisiMean;
        %legend(labels);
    end
end

% if flags.do_wsspsi
%     h = line([1,maxit],20*log10([CspsiAllMean,CspsiAllMean]));
% else
%     h = line([1,maxit],20*log10([CheapintAllMean,CheapintAllMean]));
% end
% set(h,'LineStyle','--');
% set(h,'Color','k');

if ~isempty(kv.exportdir)
    wsstring = '';
    if ~flags.do_nowarmstart
        wsstring = flags.warmstart;
        save(sprintf([kv.exportdir,filesep,'%scomparison_%s_%s.mat'],flags.winmod,kv.expname,wsstring),...
        'Cheapint','labels','res','maxit','rtisiXaxis');
    else
        save(sprintf([kv.exportdir,filesep,'%scomparison_%s_%s.mat'],flags.winmod,kv.expname,wsstring),...
        'Cheapint','labels','res','maxit','rtisiXaxis');
    end

    %saveas(gcf,sprintf([kv.exportdir,filesep,'%scomparison_%s_%s.fig'],flags.winmod,kv.expname,wsstring),'fig');
    %saveas(gcf,sprintf([kv.exportdir,filesep,'%scomparison_%s_%s.png'],flags.winmod,kv.expname,wsstring),'png');
end


function [Cres] = compareonewav(wavfile,kv,flags,outputdir,nameoutdir)
wsstring = '';
if ~flags.do_nowarmstart
    wsstring = flags.warmstart;
end

a = kv.a;
M = kv.M;
thr1 = kv.thr1;
thr2 = kv.thr2;
maxit = kv.maxit;
[~,name] = fileparts(wavfile);

[f,fs] = wavreadwrapper(wavfile);
f = normalize(f(:,1),'wav');

if ~isempty(kv.maxsamples)
    f = f(1:min([kv.maxsamples,numel(f)]));
end

Ls= numel(f);

if flags.do_storewavs
    if ~exist(outputdir, 'dir')
        mkdir(outputdir);
    end
    
    if ~exist(nameoutdir, 'dir')
        mkdir(nameoutdir);
    end
    
    wavsave(normalize(f,'wav'),fs,[nameoutdir,name,'.wav']);
end

L = dgtlength(Ls,a,M);
tfr = a*M/L;
ggauss = {'gauss',tfr,'inf'};
f = postpad(f,L);

switch flags.winmod
    case 'gauss'
        g = ggauss;
        gd = gabdual(g,a,M,L);
        gamma = tfr*L;
    case 'truncgauss'
        gnum = gabwin(ggauss,a,M,L);
        g = long2fir(gnum,M);
        gd = gabdual(g,a,M,L);
        gamma = tfr*L;
    case 'hann'
        gl = M;
        g = {'hann',gl};
        gd = gabdual(g,a,M,L);
        gamma = 0.25645*gl^2;
     case 'hamming'
        gl = M;
        g = {'hamming',gl};
        gd = gabdual(g,a,M,L);
        gamma = 0.29794*gl^2;
end

c = dgtreal(f,g,a,M,'timeinv');

tic;
chatint = pghi(abs(c),gamma,a,M,'tol',[thr1,thr2],'timeinv');
HeapintTime = toc;

fhat = idgtreal(chatint,gd,a,M,'timeinv');

%%
%
fprintf('Proposed: %.2f s\n',HeapintTime);
nextprojc = dgtreal(fhat,g,a,M,'timeinv');
Cheapint = magnitudeerr(c,nextprojc);

if flags.do_storewavs
%    Rmin = min(20*log10([norm(fhat-f),norm(fhat+f)]./f));
    os = [nameoutdir,name,'_heapint'];
    writetex([os,'.tex'],20*log10(Cheapint));
%     fileID = fopen(s,'w');
%     fprintf(fileID,'%.2f (%.2f)\n',20*log10(Cheapint),Rmin);
%     fclose(fileID);
    
    wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
end

tic;
chatspsi = spsi(abs(c),a,M,'timeinv');
spsiTime = toc;
fprintf('SPSI: %.2f s\n',spsiTime);

fhatspsi = idgtreal(chatspsi,gd,a,M,'timeinv');
nextprojc = dgtreal(fhatspsi,g,a,M,'timeinv');
Cspsi = magnitudeerr(c,nextprojc);

if flags.do_storewavs
    os = [nameoutdir,name,'_spsi'];
    writetex([os,'.tex'],20*log10(Cspsi));
    wavsave(normalize(fhatspsi,'wav'),fs,[os,'.wav']);
end

if flags.do_wsheapint
    c = chatint;
elseif flags.do_wsspsi
    c = chatspsi;
else
    c = abs(c);
end

%%
%
% if flags.do_nowarmstart
%     tic;
%     [fhat,relresglarand,~,~] = frsynabs(F,cframe,'maxit',maxit,'griflim','tol',1e-10,'quiet','rand','Fd',Fd);
%     glarandTime = toc;
%     fprintf('Grif-Lim rand: %.2f s\n',glarandTime);
%     
%     nextprojc = frana(F,fhat);
%     Cglarand = magnitudeerr(c,framecoef2native(F,nextprojc));
%     
%     if flags.do_storewavs
%         os = [nameoutdir,name,'_GLArand',wsstring];
%         writetex([os,'.tex'],20*log10(Cglarand));
%         wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
%     end
% end


tic;
[~,fhat,relresglazero] = gla(c,g,a,M,'maxit',maxit,'gla','tol',1e-10,'quiet','timeinv');
glaTime = toc;
fprintf('Grif-Lim: %.2f s\n',glaTime);

nextprojc = dgtreal(fhat,g,a,M,'timeinv');
Cglazero = magnitudeerr(c,nextprojc);

if flags.do_storewavs
    os = [nameoutdir,name,'_GLA',wsstring];
    writetex([os,'.tex'],20*log10(Cglazero));
    wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
end
%%
%

% tic;
% [fhat,relresfgla,~,chat] = frsynabs(F,cframe,'maxit',maxit,'fgriflim','tol',1e-10,'quiet','Fd',Fd);
% fglaTime = toc;
% fprintf('Fast Grif-Lim: %.2f s\n', fglaTime);
% 
% nextprojc = frana(F,fhat);
% Cfastgla = magnitudeerr(c,framecoef2native(F,nextprojc));
% 
% if flags.do_storewavs
%     os = [nameoutdir,name,'_FGLA',wsstring];
%     writetex([os,'.tex'],20*log10(Cfastgla));
%     wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
% end


if ~flags.do_excludelbfgs

    % minFunc migth not finish properly.
    try
        pause off;
        tic;
        [~,fhat,relreslbfgs] = decolbfgs(c,g,a,M,'maxit',maxit,'p',2/3,'tol',1e-9,'quiet','timeinv');
        lbfgsTime = toc;
        fprintf('lBFGS: %.2f s\n',lbfgsTime);   
        
        nextprojc = dgtreal(fhat,g,a,M,'timeinv');
        Clbfgs = magnitudeerr(c,nextprojc);
        
        if flags.do_storewavs
            os = [nameoutdir,name,'_lBFGS',wsstring];
            writetex([os,'.tex'],20*log10(Clbfgs));
            wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
        end
    catch
        err = lasterror;
        tocompare = 'frsynabs';
        if strcmpi(err.stack(1).name,tocompare)
            fprintf(err.message);
            % minFunc failed for some reason, we do not want this result to be
            % included in the average.
            relreslbfgs = nan;
            Clbfgs = nan;
            
            if flags.do_storewavs
                os = [nameoutdir,name,'_lBFGS',wsstring];
                writetex([os,'.tex'],Clbfgs);
            end
            
        else
            pause on;
            rethrow(err);
        end
    end
    pause on;
else
    Clbfgs = nan;
    relreslbfgs = nan;
end

% tic;
% [chat,relreslegla] = legla(c,g,a,M,'maxit',maxit,'modtrunc','onthefly');
% leglaTime = toc;
% fprintf('leGLA: %.2f s\n',leglaTime);
% 
% fhat = idgtreal(chat,gd,a,M);
% nextprojc = frana(F,fhat);
% Clegla = magnitudeerr(c,framecoef2native(F,nextprojc));
% 
% if flags.do_storewavs
%     os = [nameoutdir,name,'_leGLA',wsstring];
%     writetex([os,'.tex'],20*log10(Clegla));
%     wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
% end


tic;
[chat,~,relresflegla] = legla(c,g,a,M,'maxit',maxit,'modtrunc','onthefly','flegla','kernsize',[2*M/a + 1, 2*M/a + 1],'timeinv');
fleglaTime = toc;
fprintf('FleGLA: %.2f s\n',fleglaTime);

fhat = idgtreal(chat,gd,a,M,'timeinv');
nextprojc = dgtreal(fhat,g,a,M,'timeinv');
Cflegla = magnitudeerr(c,nextprojc);

if flags.do_storewavs
    os = [nameoutdir,name,'_FleGLA',wsstring];
    writetex([os,'.tex'],20*log10(Cflegla));
    wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
end

if flags.do_nowarmstart
    relresrtisi = zeros(numel(kv.rtisiiters),1);
    
    
    for iIt=1:numel(kv.rtisiiters)
        tic;
        [chat,~,relresrtisi(iIt)] = lertisila(c,g,a,M,'maxit',kv.rtisiiters(iIt),'lookahead',M/a-1,'timeinv');
        rtisiTime = toc;
        fprintf('RTISI-LA, %i, %.2f s\n',kv.rtisiiters(iIt)*M/a,rtisiTime);
    end
    fhat = idgtreal(chat,gd,a,M,'timeinv');
    nextprojc = dgtreal(fhat,g,a,M,'timeinv');
    Crtisi = magnitudeerr(c,nextprojc);

    if flags.do_storewavs
        os = [nameoutdir,name,'_RTISILA',wsstring];
        writetex([os,'.tex'],20*log10(Crtisi));
        wavsave(normalize(fhat,'wav'),fs,[os,'.wav']);
    end
    
end


if ~flags.do_nowarmstart
    Crelres = {relresglazero,relreslbfgs,relresflegla};
    Cfinal = {Cglazero,Clbfgs,Cflegla};
else
    Crelres = {relresglazero,relreslbfgs,relresflegla,relresrtisi};
    Cfinal = {Cglazero,Clbfgs,Cflegla,Crtisi};
end

Cres = {Cheapint,Cspsi,Crelres,Cfinal};

function writetex(s,val)
fileID = fopen(s,'w');
fprintf(fileID,'%.2f\n',val);
fclose(fileID);


